{ *************************************************************************** }
{ TMS Cryptography Pack                                                       }
{ for Delphi & C++Builder                                                     }
{                                                                             }
{ Written by Cyberens Technologies & Services                                 }
{ Exclusively commercialized by tmssoftware.com bvba                          }
{ copyright  2016 - 2020 by Cyberens Technologies & Services                 }
{ Email : info@tmssoftware.com                                                }
{ Web : http://www.tmssoftware.com                                            }
{                                                                             }
{ The source code is given as is. The author is not responsible               }
{ for any possible damage done due to the use of this code.                   }
{ The component can be freely used in any application. The complete           }
{ source code remains property of the author and may not be distributed,      }
{ published, given or sold in any form as such. No parts of the source        }
{ code can be included in any other component or application without          }
{ written authorization of the author.                                        }
{ *************************************************************************** }

unit CryptBase;

{$I TMSDEFS.INC}
{$R TMSCPPackageResource.res}

interface

uses
  Classes;

type

  TTMSCryptBase = class(TComponent)
    function GetVersion: string;
    procedure SetVersion(const Value: string);
  protected
    function GetVersionNr: integer; virtual;
  published
    property Version: string read GetVersion write SetVersion;
  end;

implementation

uses
{$IFDEF MSWINDOWS}
  Winapi.Windows,
{$ENDIF}
{$IF (defined(MSWINDOWS) or defined(MACOS)) and (not defined(IOS))}
  AnsiStrings,
{$IFEND}
  SysUtils;

{$IFNDEF MSWINDOWS}

function HiWord(x: longword): word;
begin
  HiWord := (x and $FFFF0000) shr 16;
end;

function LoWord(x: longword): word;
begin
  LoWord := (x and $0000FFFF);
end;
{$ENDIF}
{ TTMSCryptBase }

function TTMSCryptBase.GetVersion: string;
var
  vn: integer;
begin
  vn := GetVersionNr;
  Result := IntToStr(Hi(HiWord(vn))) + '.' + IntToStr(Lo(HiWord(vn))) + '.' +
    IntToStr(Hi(LoWord(vn))) + '.' + IntToStr(Lo(LoWord(vn)));
end;

function TTMSCryptBase.GetVersionNr: integer;
begin
  Result := $04020601;
end;

procedure TTMSCryptBase.SetVersion(const Value: string);
begin
  //
end;

{$IFDEF MSWINDOWS}
{$IFDEF FREEWARE}
{$I TRIAL.INC}
{$ENDIF}
{$ENDIF}

end.


