program Project1;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils,
  HashObj, MiscObj, SPECKObj;

function hash(tx:String):String;
  var
    sha3: TSHA3Hash;

begin
  sha3:= TSHA3Hash.Create;
  try
    sha3.AType:= txof;
    sha3.HashSizeBits:=1024;
    sha3.Version:=512;
    sha3.OutputFormat:= hexa;
    sha3.Unicode := yesUni;
    result:=pChar(sha3.Hash(tx));
  finally
    FreeAndNil(sha3);
  end;
end;

function speck(tx:string):String;
var
 speck: TSPECKEncryption;

begin
 speck:= TSPECKEncryption.Create;
 speck.AType:= stCBC;
 speck.WordSizeBits:= wsb32;
 speck.KeySizeWords:= ksw4;
 speck.Key:= '0123456789012345';
 speck.OutputFormat:= hexa;
 speck.Unicode := noUni;
 speck.PaddingMode:= TSPECKPaddingMode.PKCS7;
 speck.IVMode:= TSPECKIVMode.rand;
 Result:= speck.Encrypt('test');
 speck.Free;
end;

begin
  try
    { TODO -oUser -cConsole Main : Insert code here }
    writeln(hash('password'));
    readln;

  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
